Option to include man pages in documentation
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
27 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
28 CHECK_VERSION = $(top_srcdir)/autotools/check-version
29 CHECK_NEWS = $(top_srcdir)/autotools/check-news
30 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
31 DOCPP = $(top_srcdir)/autotools/docpp
32 REPLACE_VARS_SED = autotools/replace_vars.sed
33 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
34 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
35 SHELL_ENV_INIT = autotools/shell-env-init
36
37 # Note: these are automake-specific variables, and must be named after
38 # the directory + 'dir' suffix
39 clientdir = $(pkgpythondir)/client
40 hypervisordir = $(pkgpythondir)/hypervisor
41 httpdir = $(pkgpythondir)/http
42 masterddir = $(pkgpythondir)/masterd
43 confddir = $(pkgpythondir)/confd
44 rapidir = $(pkgpythondir)/rapi
45 serverdir = $(pkgpythondir)/server
46 watcherdir = $(pkgpythondir)/watcher
47 impexpddir = $(pkgpythondir)/impexpd
48 utilsdir = $(pkgpythondir)/utils
49 toolsdir = $(pkglibdir)/tools
50 iallocatorsdir = $(pkglibdir)/iallocators
51 pytoolsdir = $(pkgpythondir)/tools
52 docdir = $(datadir)/doc/$(PACKAGE)
53 myexeclibdir = $(pkglibdir)
54
55 # Delete output file if an error occurred while building it
56 .DELETE_ON_ERROR:
57
58 HS_DIRS = \
59         src \
60         src/Ganeti \
61         src/Ganeti/Block \
62         src/Ganeti/Block/Drbd \
63         src/Ganeti/Confd \
64         src/Ganeti/DataCollectors \
65         src/Ganeti/HTools \
66         src/Ganeti/HTools/Backend \
67         src/Ganeti/HTools/Program \
68         src/Ganeti/Query \
69         test/hs \
70         test/hs/Test \
71         test/hs/Test/Ganeti \
72         test/hs/Test/Ganeti/Block \
73         test/hs/Test/Ganeti/Block/Drbd \
74         test/hs/Test/Ganeti/Confd \
75         test/hs/Test/Ganeti/HTools \
76         test/hs/Test/Ganeti/HTools/Backend \
77         test/hs/Test/Ganeti/Query
78
79 DIRS = \
80         $(HS_DIRS) \
81         autotools \
82         daemons \
83         devel \
84         doc \
85         doc/css \
86         doc/examples \
87         doc/examples/gnt-debug \
88         doc/examples/hooks \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/hs/shelltests \
92         lib \
93         lib/build \
94         lib/client \
95         lib/confd \
96         lib/http \
97         lib/hypervisor \
98         lib/impexpd \
99         lib/masterd \
100         lib/rapi \
101         lib/server \
102         lib/tools \
103         lib/utils \
104         lib/watcher \
105         man \
106         qa \
107         test \
108         test/data \
109         test/data/ovfdata \
110         test/data/ovfdata/other \
111         test/py \
112         tools
113
114 ALL_APIDOC_HS_DIRS = \
115         $(APIDOC_HS_DIR) \
116         $(APIDOC_HS_DIR)/Ganeti \
117         $(APIDOC_HS_DIR)/Ganeti/Block \
118         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
119         $(APIDOC_HS_DIR)/Ganeti/Confd \
120         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
121         $(APIDOC_HS_DIR)/Ganeti/HTools \
122         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
123         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
124         $(APIDOC_HS_DIR)/Ganeti/Query
125
126 BUILDTIME_DIR_AUTOCREATE = \
127         scripts \
128         $(APIDOC_DIR) \
129         $(ALL_APIDOC_HS_DIRS) \
130         $(APIDOC_PY_DIR) \
131         $(COVERAGE_DIR) \
132         $(COVERAGE_HS_DIR) \
133         $(COVERAGE_PY_DIR) \
134         .hpc
135
136 BUILDTIME_DIRS = \
137         $(BUILDTIME_DIR_AUTOCREATE) \
138         doc/html \
139         doc/man-html
140
141 DIRCHECK_EXCLUDE = \
142         $(BUILDTIME_DIRS) \
143         ganeti-[0-9]*.[0-9]*.[0-9]* \
144         doc/html/_* \
145         doc/man-html/_* \
146         autom4te.cache
147
148 # some helper vars
149 COVERAGE_DIR = doc/coverage
150 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
151 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
152 APIDOC_DIR = doc/api
153 APIDOC_PY_DIR = $(APIDOC_DIR)/py
154 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
155
156 MAINTAINERCLEANFILES = \
157         $(maninput) \
158         doc/install-quick.rst \
159         doc/news.rst \
160         doc/upgrade.rst \
161         vcs-version
162
163 maintainer-clean-local:
164         rm -rf $(BUILDTIME_DIRS)
165
166 CLEANFILES = \
167         $(addsuffix /*.py[co],$(DIRS)) \
168         $(addsuffix /*.hi,$(HS_DIRS)) \
169         $(addsuffix /*.o,$(HS_DIRS)) \
170         $(PYTHON_BOOTSTRAP) \
171         epydoc.conf \
172         $(REPLACE_VARS_SED) \
173         $(SHELL_ENV_INIT) \
174         daemons/daemon-util \
175         daemons/ganeti-cleaner \
176         $(mandocrst) \
177         doc/manpages-enabled.rst \
178         $(BUILT_EXAMPLES) \
179         doc/examples/bash_completion \
180         doc/examples/bash_completion-debug \
181         lib/_generated_rpc.py \
182         $(man_MANS) \
183         $(manhtml) \
184         tools/kvm-ifup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/ht.py \
256         lib/jqueue.py \
257         lib/jstore.py \
258         lib/locking.py \
259         lib/luxi.py \
260         lib/mcpu.py \
261         lib/netutils.py \
262         lib/objects.py \
263         lib/objectutils.py \
264         lib/opcodes.py \
265         lib/ovf.py \
266         lib/pathutils.py \
267         lib/qlang.py \
268         lib/query.py \
269         lib/rpc.py \
270         lib/rpc_defs.py \
271         lib/runtime.py \
272         lib/serializer.py \
273         lib/ssconf.py \
274         lib/ssh.py \
275         lib/storage.py \
276         lib/uidpool.py \
277         lib/vcluster.py \
278         lib/network.py \
279         lib/workerpool.py
280
281 client_PYTHON = \
282         lib/client/__init__.py \
283         lib/client/gnt_backup.py \
284         lib/client/gnt_cluster.py \
285         lib/client/gnt_debug.py \
286         lib/client/gnt_group.py \
287         lib/client/gnt_instance.py \
288         lib/client/gnt_job.py \
289         lib/client/gnt_node.py \
290         lib/client/gnt_network.py \
291         lib/client/gnt_os.py \
292         lib/client/gnt_storage.py
293
294 hypervisor_PYTHON = \
295         lib/hypervisor/__init__.py \
296         lib/hypervisor/hv_base.py \
297         lib/hypervisor/hv_chroot.py \
298         lib/hypervisor/hv_fake.py \
299         lib/hypervisor/hv_kvm.py \
300         lib/hypervisor/hv_lxc.py \
301         lib/hypervisor/hv_xen.py
302
303 rapi_PYTHON = \
304         lib/rapi/__init__.py \
305         lib/rapi/baserlib.py \
306         lib/rapi/client.py \
307         lib/rapi/client_utils.py \
308         lib/rapi/connector.py \
309         lib/rapi/rlib2.py \
310         lib/rapi/testutils.py
311
312 http_PYTHON = \
313         lib/http/__init__.py \
314         lib/http/auth.py \
315         lib/http/client.py \
316         lib/http/server.py
317
318 confd_PYTHON = \
319         lib/confd/__init__.py \
320         lib/confd/client.py
321
322 masterd_PYTHON = \
323         lib/masterd/__init__.py \
324         lib/masterd/iallocator.py \
325         lib/masterd/instance.py
326
327 impexpd_PYTHON = \
328         lib/impexpd/__init__.py
329
330 watcher_PYTHON = \
331         lib/watcher/__init__.py \
332         lib/watcher/nodemaint.py \
333         lib/watcher/state.py
334
335 server_PYTHON = \
336         lib/server/__init__.py \
337         lib/server/masterd.py \
338         lib/server/noded.py \
339         lib/server/rapi.py
340
341 pytools_PYTHON = \
342         lib/tools/__init__.py \
343         lib/tools/ensure_dirs.py \
344         lib/tools/node_cleanup.py \
345         lib/tools/node_daemon_setup.py \
346         lib/tools/prepare_node_join.py
347
348 utils_PYTHON = \
349         lib/utils/__init__.py \
350         lib/utils/algo.py \
351         lib/utils/filelock.py \
352         lib/utils/hash.py \
353         lib/utils/io.py \
354         lib/utils/log.py \
355         lib/utils/lvm.py \
356         lib/utils/mlock.py \
357         lib/utils/nodesetup.py \
358         lib/utils/process.py \
359         lib/utils/retry.py \
360         lib/utils/text.py \
361         lib/utils/wrapper.py \
362         lib/utils/x509.py
363
364 docinput = \
365         doc/conf.py \
366         doc/css/style.css \
367         doc/admin.rst \
368         doc/cluster-merge.rst \
369         doc/design-2.0.rst \
370         doc/design-2.1.rst \
371         doc/design-2.2.rst \
372         doc/design-2.3.rst \
373         doc/design-2.4.rst \
374         doc/design-2.5.rst \
375         doc/design-2.6.rst \
376         doc/design-2.7.rst \
377         doc/design-autorepair.rst \
378         doc/design-bulk-create.rst \
379         doc/design-chained-jobs.rst \
380         doc/design-cpu-pinning.rst \
381         doc/design-draft.rst \
382         doc/design-htools-2.3.rst \
383         doc/design-http-server.rst \
384         doc/design-impexp2.rst \
385         doc/design-lu-generated-jobs.rst \
386         doc/design-linuxha.rst \
387         doc/design-multi-reloc.rst \
388         doc/design-network.rst \
389         doc/design-node-add.rst \
390         doc/design-oob.rst \
391         doc/design-ovf-support.rst \
392         doc/design-opportunistic-locking.rst \
393         doc/design-partitioned.rst \
394         doc/design-query-splitting.rst \
395         doc/design-query2.rst \
396         doc/design-remote-commands.rst \
397         doc/design-resource-model.rst \
398         doc/design-shared-storage.rst \
399         doc/design-monitoring-agent.rst \
400         doc/design-virtual-clusters.rst \
401         doc/design-x509-ca.rst \
402         doc/devnotes.rst \
403         doc/glossary.rst \
404         doc/hooks.rst \
405         doc/iallocator.rst \
406         doc/index.rst \
407         doc/install-quick.rst \
408         doc/install.rst \
409         doc/locking.rst \
410         doc/manpages-disabled.rst \
411         doc/move-instance.rst \
412         doc/news.rst \
413         doc/ovfconverter.rst \
414         doc/rapi.rst \
415         doc/security.rst \
416         doc/upgrade.rst \
417         doc/virtual-cluster.rst \
418         doc/walkthrough.rst
419
420 # Generates file names such as "doc/man-gnt-instance.rst"
421 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
422
423 # Haskell programs to be installed in $PREFIX/bin
424 HS_BIN_PROGS=src/htools
425
426 # Haskell programs to be installed in the MYEXECLIB dir
427 HS_MYEXECLIB_PROGS=src/mon-collector
428
429 # Haskell programs to compiled but not installed automatically
430 # Usually they have their own specific installation rules
431 HS_COMPILE_PROGS= \
432         src/hconfd \
433         src/rpc-test
434
435 # All Haskell non-test programs to be compiled but not automatically installed
436 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
437
438 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
439 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
440
441 HS_ALL_PROGS = \
442         $(HS_PROGS) \
443         test/hs/hpc-htools \
444         test/hs/hpc-mon-collector \
445         test/hs/htest \
446         $(HS_COMPILE_PROGS)
447
448 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
449 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
450
451 HFLAGS = \
452         -O -Wall -Werror -isrc \
453         -fwarn-monomorphism-restriction \
454         -fwarn-tabs \
455         $(GHC_BYVERSION_FLAGS)
456
457 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
458 HEXTRA =
459 # internal extra flags (used for test/hs/htest mainly)
460 HEXTRA_INT =
461 # exclude options for coverage reports
462 HPCEXCL = --exclude Main \
463         --exclude Ganeti.Constants \
464         --exclude Ganeti.HTools.QC \
465         --exclude Ganeti.THH \
466         --exclude Ganeti.Version \
467         --exclude Test.Ganeti.Attoparsec \
468         --exclude Test.Ganeti.TestCommon \
469         --exclude Test.Ganeti.TestHTools \
470         --exclude Test.Ganeti.TestHelper \
471         --exclude Test.Ganeti.TestImports \
472         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
473
474 HS_LIB_SRCS = \
475         src/Ganeti/Block/Drbd/Types.hs \
476         src/Ganeti/Block/Drbd/Parser.hs \
477         src/Ganeti/BasicTypes.hs \
478         src/Ganeti/Common.hs \
479         src/Ganeti/Compat.hs \
480         src/Ganeti/Confd/Client.hs \
481         src/Ganeti/Confd/Server.hs \
482         src/Ganeti/Confd/Types.hs \
483         src/Ganeti/Confd/Utils.hs \
484         src/Ganeti/Config.hs \
485         src/Ganeti/Daemon.hs \
486         src/Ganeti/DataCollectors/CLI.hs \
487         src/Ganeti/DataCollectors/Drbd.hs \
488         src/Ganeti/DataCollectors/Program.hs \
489         src/Ganeti/Errors.hs \
490         src/Ganeti/HTools/Backend/IAlloc.hs \
491         src/Ganeti/HTools/Backend/Luxi.hs \
492         src/Ganeti/HTools/Backend/Rapi.hs \
493         src/Ganeti/HTools/Backend/Simu.hs \
494         src/Ganeti/HTools/Backend/Text.hs \
495         src/Ganeti/HTools/CLI.hs \
496         src/Ganeti/HTools/Cluster.hs \
497         src/Ganeti/HTools/Container.hs \
498         src/Ganeti/HTools/ExtLoader.hs \
499         src/Ganeti/HTools/Graph.hs \
500         src/Ganeti/HTools/Group.hs \
501         src/Ganeti/HTools/Instance.hs \
502         src/Ganeti/HTools/Loader.hs \
503         src/Ganeti/HTools/Node.hs \
504         src/Ganeti/HTools/PeerMap.hs \
505         src/Ganeti/HTools/Program/Hail.hs \
506         src/Ganeti/HTools/Program/Hbal.hs \
507         src/Ganeti/HTools/Program/Hcheck.hs \
508         src/Ganeti/HTools/Program/Hinfo.hs \
509         src/Ganeti/HTools/Program/Hscan.hs \
510         src/Ganeti/HTools/Program/Hspace.hs \
511         src/Ganeti/HTools/Program/Hroller.hs \
512         src/Ganeti/HTools/Program/Main.hs \
513         src/Ganeti/HTools/Types.hs \
514         src/Ganeti/Hash.hs \
515         src/Ganeti/JQueue.hs \
516         src/Ganeti/JSON.hs \
517         src/Ganeti/Jobs.hs \
518         src/Ganeti/Logging.hs \
519         src/Ganeti/Luxi.hs \
520         src/Ganeti/Network.hs \
521         src/Ganeti/Objects.hs \
522         src/Ganeti/OpCodes.hs \
523         src/Ganeti/OpParams.hs \
524         src/Ganeti/Path.hs \
525         src/Ganeti/Query/Common.hs \
526         src/Ganeti/Query/Filter.hs \
527         src/Ganeti/Query/Group.hs \
528         src/Ganeti/Query/Job.hs \
529         src/Ganeti/Query/Language.hs \
530         src/Ganeti/Query/Node.hs \
531         src/Ganeti/Query/Query.hs \
532         src/Ganeti/Query/Server.hs \
533         src/Ganeti/Query/Types.hs \
534         src/Ganeti/Rpc.hs \
535         src/Ganeti/Runtime.hs \
536         src/Ganeti/Ssconf.hs \
537         src/Ganeti/THH.hs \
538         src/Ganeti/Types.hs \
539         src/Ganeti/Utils.hs
540
541 HS_TEST_SRCS = \
542         test/hs/Test/Ganeti/Attoparsec.hs \
543         test/hs/Test/Ganeti/BasicTypes.hs \
544         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
545         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
546         test/hs/Test/Ganeti/Common.hs \
547         test/hs/Test/Ganeti/Confd/Types.hs \
548         test/hs/Test/Ganeti/Confd/Utils.hs \
549         test/hs/Test/Ganeti/Daemon.hs \
550         test/hs/Test/Ganeti/Errors.hs \
551         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
552         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
553         test/hs/Test/Ganeti/HTools/CLI.hs \
554         test/hs/Test/Ganeti/HTools/Cluster.hs \
555         test/hs/Test/Ganeti/HTools/Container.hs \
556         test/hs/Test/Ganeti/HTools/Graph.hs \
557         test/hs/Test/Ganeti/HTools/Instance.hs \
558         test/hs/Test/Ganeti/HTools/Loader.hs \
559         test/hs/Test/Ganeti/HTools/Node.hs \
560         test/hs/Test/Ganeti/HTools/PeerMap.hs \
561         test/hs/Test/Ganeti/HTools/Types.hs \
562         test/hs/Test/Ganeti/JSON.hs \
563         test/hs/Test/Ganeti/Jobs.hs \
564         test/hs/Test/Ganeti/JQueue.hs \
565         test/hs/Test/Ganeti/Luxi.hs \
566         test/hs/Test/Ganeti/Network.hs \
567         test/hs/Test/Ganeti/Objects.hs \
568         test/hs/Test/Ganeti/OpCodes.hs \
569         test/hs/Test/Ganeti/Query/Filter.hs \
570         test/hs/Test/Ganeti/Query/Language.hs \
571         test/hs/Test/Ganeti/Query/Query.hs \
572         test/hs/Test/Ganeti/Rpc.hs \
573         test/hs/Test/Ganeti/Ssconf.hs \
574         test/hs/Test/Ganeti/THH.hs \
575         test/hs/Test/Ganeti/TestCommon.hs \
576         test/hs/Test/Ganeti/TestHTools.hs \
577         test/hs/Test/Ganeti/TestHelper.hs \
578         test/hs/Test/Ganeti/Types.hs \
579         test/hs/Test/Ganeti/Utils.hs
580
581 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
582
583 HS_BUILT_SRCS = \
584         test/hs/Test/Ganeti/TestImports.hs \
585         src/Ganeti/Constants.hs \
586         src/Ganeti/Version.hs
587 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
588
589 $(RUN_IN_TEMPDIR): | stamp-directories
590
591 doc/html/index.html: ENABLE_MANPAGES =
592 doc/man-html/index.html: ENABLE_MANPAGES = 1
593 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
594
595 # Note: we use here an order-only prerequisite, as the contents of
596 # _autoconf.py are not actually influencing the html build output: it
597 # has to exist in order for the sphinx module to be loaded
598 # successfully, but we certainly don't want the docs to be rebuilt if
599 # it changes
600 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
601         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
602         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
603         doc/css/style.css \
604         | $(BUILT_PYTHON_SOURCES)
605         @test -n "$(SPHINX)" || \
606             { echo 'sphinx-build' not found during configure; exit 1; }
607 if !MANPAGES_IN_DOC
608         if test -n '$(ENABLE_MANPAGES)'; then \
609           echo 'Man pages in documentation were disabled at configure time' >&2; \
610           exit 1; \
611         fi
612 endif
613         dir=$(dir $@) && \
614         @mkdir_p@ $$dir && \
615         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) \
616         $(RUN_IN_TEMPDIR) bash autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
617             -d . \
618             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
619             -D release="$(PACKAGE_VERSION)" \
620             -D graphviz_dot="$(DOT)" \
621             -D enable_manpages="$(ENABLE_MANPAGES)" \
622             doc $(CURDIR)/$$dir && \
623         rm -f $$dir/.buildinfo $$dir/objects.inv
624         touch $@
625
626 doc/html: doc/html/index.html
627
628 doc/man-html: doc/man-html/index.html
629
630 doc/install-quick.rst: INSTALL
631 doc/news.rst: NEWS
632 doc/upgrade.rst: UPGRADE
633
634 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
635         set -e; \
636         { echo '.. This file is automatically updated at build time from $<.'; \
637           echo '.. Do not edit.'; \
638           echo; \
639           cat $<; \
640         } > $@
641
642 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
643         { echo '.. This file is automatically generated, do not edit!'; \
644           echo ''; \
645           echo 'Man pages'; \
646           echo '========='; \
647           echo; \
648           echo '.. toctree::'; \
649           echo '   :maxdepth: 1'; \
650           echo; \
651           for i in $(notdir $(mandocrst)); do \
652             echo "   $$i"; \
653           done | LC_ALL=C sort; \
654         } > $@
655
656 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
657 if MANPAGES_IN_DOC
658         { echo '.. This file is automatically updated at build time from $<.'; \
659           echo '.. Do not edit.'; \
660           echo; \
661           echo "$*"; \
662           echo '=========================================='; \
663           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
664         } > $@
665 else
666         echo 'Man pages in documentation were disabled at configure time' >&2; \
667         exit 1;
668 endif
669
670 # Things to build but not to install (add it to EXTRA_DIST if it should be
671 # distributed)
672 noinst_DATA = \
673         doc/html \
674         $(BUILT_EXAMPLES) \
675         doc/examples/bash_completion \
676         doc/examples/bash_completion-debug \
677         $(manhtml)
678
679 if MANPAGES_IN_DOC
680 noinst_DATA += doc/man-html
681 endif
682
683 gnt_scripts = \
684         scripts/gnt-backup \
685         scripts/gnt-cluster \
686         scripts/gnt-debug \
687         scripts/gnt-group \
688         scripts/gnt-instance \
689         scripts/gnt-job \
690         scripts/gnt-network \
691         scripts/gnt-node \
692         scripts/gnt-os \
693         scripts/gnt-storage
694
695 PYTHON_BOOTSTRAP_SBIN = \
696         daemons/ganeti-masterd \
697         daemons/ganeti-noded \
698         daemons/ganeti-rapi \
699         daemons/ganeti-watcher \
700         $(gnt_scripts)
701
702 PYTHON_BOOTSTRAP = \
703         $(PYTHON_BOOTSTRAP_SBIN) \
704         tools/ensure-dirs \
705         tools/node-cleanup \
706         tools/node-daemon-setup \
707         tools/prepare-node-join
708
709 qa_scripts = \
710         qa/__init__.py \
711         qa/ganeti-qa.py \
712         qa/qa_cluster.py \
713         qa/qa_config.py \
714         qa/qa_daemon.py \
715         qa/qa_env.py \
716         qa/qa_error.py \
717         qa/qa_group.py \
718         qa/qa_instance.py \
719         qa/qa_job.py \
720         qa/qa_node.py \
721         qa/qa_os.py \
722         qa/qa_rapi.py \
723         qa/qa_tags.py \
724         qa/qa_utils.py
725
726 bin_SCRIPTS =
727 if WANT_HTOOLS
728 bin_SCRIPTS += $(HS_BIN_PROGS)
729 install-exec-hook:
730         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
731 # FIXME: this is a hardcoded logic, instead of auto-resolving
732         $(LN_S) -f ../../../bin/htools \
733           $(DESTDIR)$(iallocatorsdir)/hail
734         for role in $(HS_BIN_ROLES); do \
735           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
736         done
737 endif
738
739 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
740         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
741           echo "Error: cannot run unittests without the development" \
742                " libraries (see devnotes.rst)" 1>&2; \
743           exit 1; \
744         fi
745         @rm -f $(notdir $@).tix
746         $(GHC) --make \
747           $(HFLAGS) \
748           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
749           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
750           $(HEXTRA) $(HEXTRA_INT) $@
751         @touch "$@"
752
753 # for the test/hs/htest binary, we need to enable profiling/coverage
754 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
755
756 # we compile the hpc-htools binary with the program coverage
757 test/hs/hpc-htools: HEXTRA_INT=-fhpc
758
759 # we compile the hpc-mon-collector binary with the program coverage
760 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
761
762 # test dependency
763 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
764
765 # rules for building profiling-enabled versions of the haskell
766 # programs: hs-prof does the full two-step build, whereas
767 # hs-prof-quick does only the final rebuild (hs-prof must have been
768 # run before)
769 .PHONY: hs-prof hs-prof-quick
770 hs-prof:
771         @if [ -z "$(TARGET)" ]; then \
772           echo "You need to define TARGET when running this rule" 1>&2; \
773           exit 1; \
774         fi
775         $(MAKE) $(AM_MAKEFLAGS) clean
776         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
777         rm -f $(HS_ALL_PROGS)
778         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
779
780 hs-prof-quick:
781         @if [ -z "$(TARGET)" ]; then \
782           echo "You need to define TARGET when running this rule" 1>&2; \
783           exit 1; \
784         fi
785         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
786
787 dist_sbin_SCRIPTS = \
788         tools/ganeti-listrunner
789
790 nodist_sbin_SCRIPTS = \
791         $(PYTHON_BOOTSTRAP_SBIN) \
792         daemons/ganeti-cleaner
793
794 if ENABLE_CONFD
795 src/ganeti-confd: src/hconfd
796         cp -f $< $@
797
798 nodist_sbin_SCRIPTS += src/ganeti-confd
799 endif
800
801 python_scripts = \
802         tools/burnin \
803         tools/cfgshell \
804         tools/cfgupgrade \
805         tools/cfgupgrade12 \
806         tools/cluster-merge \
807         tools/confd-client \
808         tools/fmtjson \
809         tools/lvmstrap \
810         tools/move-instance \
811         tools/ovfconverter \
812         tools/sanitize-config
813
814 dist_tools_SCRIPTS = \
815         $(python_scripts) \
816         tools/kvm-console-wrapper \
817         tools/master-ip-setup \
818         tools/xen-console-wrapper
819
820 nodist_tools_python_scripts = \
821         tools/node-cleanup
822
823 nodist_tools_SCRIPTS = \
824         $(nodist_tools_python_scripts) \
825         tools/vcluster-setup
826
827 pkglib_python_scripts = \
828         daemons/import-export \
829         tools/check-cert-expired
830
831 nodist_pkglib_python_scripts = \
832         tools/ensure-dirs \
833         tools/node-daemon-setup \
834         tools/prepare-node-join
835
836 myexeclib_SCRIPTS = \
837         daemons/daemon-util \
838         tools/kvm-ifup \
839         $(pkglib_python_scripts) \
840         $(HS_MYEXECLIB_PROGS)
841
842 nodist_myexeclib_SCRIPTS = \
843         $(nodist_pkglib_python_scripts)
844
845 EXTRA_DIST = \
846         NEWS \
847         UPGRADE \
848         epydoc.conf.in \
849         pylintrc \
850         autotools/build-bash-completion \
851         autotools/build-rpc \
852         autotools/check-header \
853         autotools/check-imports \
854         autotools/check-man-dashes \
855         autotools/check-man-references \
856         autotools/check-man-warnings \
857         autotools/check-news \
858         autotools/check-python-code \
859         autotools/check-tar \
860         autotools/check-version \
861         autotools/convert-constants \
862         autotools/docpp \
863         autotools/gen-py-coverage \
864         autotools/sphinx-wrapper \
865         autotools/testrunner \
866         autotools/wrong-hardcoded-paths \
867         $(RUN_IN_TEMPDIR) \
868         daemons/daemon-util.in \
869         daemons/ganeti-cleaner.in \
870         $(pkglib_python_scripts) \
871         devel/upload \
872         devel/webserver \
873         tools/kvm-ifup.in \
874         tools/vcluster-setup.in \
875         $(docinput) \
876         doc/html \
877         $(BUILT_EXAMPLES:%=%.in) \
878         doc/examples/ganeti.default \
879         doc/examples/ganeti.default-debug \
880         doc/examples/hooks/ethers \
881         doc/examples/gnt-debug/README \
882         doc/examples/gnt-debug/delay0.json \
883         doc/examples/gnt-debug/delay50.json \
884         test/py/lockperf.py \
885         test/py/testutils.py \
886         test/py/mocks.py \
887         $(dist_TESTS) \
888         $(TEST_FILES) \
889         man/footer.rst \
890         $(manrst) \
891         $(maninput) \
892         qa/qa-sample.json \
893         $(qa_scripts) \
894         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
895         $(HS_PROG_SRCS) \
896         src/lint-hints.hs \
897         test/hs/cli-tests-defs.sh \
898         test/hs/offline-test.sh \
899         .ghci
900
901 man_MANS = \
902         man/ganeti-cleaner.8 \
903         man/ganeti-confd.8 \
904         man/ganeti-listrunner.8 \
905         man/ganeti-masterd.8 \
906         man/ganeti-noded.8 \
907         man/ganeti-os-interface.7 \
908         man/ganeti-extstorage-interface.7 \
909         man/ganeti-rapi.8 \
910         man/ganeti-watcher.8 \
911         man/ganeti.7 \
912         man/gnt-backup.8 \
913         man/gnt-cluster.8 \
914         man/gnt-debug.8 \
915         man/gnt-group.8 \
916         man/gnt-network.8 \
917         man/gnt-instance.8 \
918         man/gnt-job.8 \
919         man/gnt-node.8 \
920         man/gnt-os.8 \
921         man/gnt-storage.8 \
922         man/hail.1 \
923         man/hbal.1 \
924         man/hcheck.1 \
925         man/hinfo.1 \
926         man/hscan.1 \
927         man/hspace.1 \
928         man/hroller.1 \
929         man/htools.1 \
930         man/mon-collector.7
931
932 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
933 manhtml = $(patsubst %.rst,%.html,$(manrst))
934 mangen = $(patsubst %.rst,%.gen,$(manrst))
935 maninput = \
936         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
937         $(patsubst %.html,%.html.in,$(manhtml)) \
938         $(mangen)
939
940 TEST_FILES = \
941         test/data/htools/clean-nonzero-score.data \
942         test/data/htools/common-suffix.data \
943         test/data/htools/empty-cluster.data \
944         test/data/htools/hail-alloc-drbd.json \
945         test/data/htools/hail-change-group.json \
946         test/data/htools/hail-invalid-reloc.json \
947         test/data/htools/hail-node-evac.json \
948         test/data/htools/hail-reloc-drbd.json \
949         test/data/htools/hbal-excl-tags.data \
950         test/data/htools/hbal-split-insts.data \
951         test/data/htools/invalid-node.data \
952         test/data/htools/missing-resources.data \
953         test/data/htools/n1-failure.data \
954         test/data/htools/rapi/groups.json \
955         test/data/htools/rapi/info.json \
956         test/data/htools/rapi/instances.json \
957         test/data/htools/rapi/nodes.json \
958         test/hs/shelltests/htools-balancing.test \
959         test/hs/shelltests/htools-basic.test \
960         test/hs/shelltests/htools-dynutil.test \
961         test/hs/shelltests/htools-excl.test \
962         test/hs/shelltests/htools-hail.test \
963         test/hs/shelltests/htools-hspace.test \
964         test/hs/shelltests/htools-invalid.test \
965         test/hs/shelltests/htools-multi-group.test \
966         test/hs/shelltests/htools-no-backend.test \
967         test/hs/shelltests/htools-rapi.test \
968         test/hs/shelltests/htools-single-group.test \
969         test/hs/shelltests/htools-text-backend.test \
970         test/hs/shelltests/htools-mon-collector.test \
971         test/data/bdev-drbd-8.0.txt \
972         test/data/bdev-drbd-8.3.txt \
973         test/data/bdev-drbd-disk.txt \
974         test/data/bdev-drbd-net-ip4.txt \
975         test/data/bdev-drbd-net-ip6.txt \
976         test/data/cert1.pem \
977         test/data/cert2.pem \
978         test/data/instance-minor-pairing.txt \
979         test/data/ip-addr-show-dummy0.txt \
980         test/data/ip-addr-show-lo-ipv4.txt \
981         test/data/ip-addr-show-lo-ipv6.txt \
982         test/data/ip-addr-show-lo-oneline-ipv4.txt \
983         test/data/ip-addr-show-lo-oneline-ipv6.txt \
984         test/data/ip-addr-show-lo-oneline.txt \
985         test/data/ip-addr-show-lo.txt \
986         test/data/kvm_0.12.5_help.txt \
987         test/data/kvm_0.15.90_help.txt \
988         test/data/kvm_0.9.1_help.txt \
989         test/data/kvm_0.9.1_help_boot_test.txt \
990         test/data/kvm_1.0_help.txt \
991         test/data/kvm_1.1.2_help.txt \
992         test/data/ovfdata/compr_disk.vmdk.gz \
993         test/data/ovfdata/config.ini \
994         test/data/ovfdata/corrupted_resources.ovf \
995         test/data/ovfdata/empty.ini \
996         test/data/ovfdata/empty.ovf \
997         test/data/ovfdata/ganeti.mf \
998         test/data/ovfdata/ganeti.ovf \
999         test/data/ovfdata/gzip_disk.ovf \
1000         test/data/ovfdata/new_disk.vmdk \
1001         test/data/ovfdata/no_disk.ini \
1002         test/data/ovfdata/no_disk_in_ref.ovf \
1003         test/data/ovfdata/no_os.ini \
1004         test/data/ovfdata/no_ovf.ova \
1005         test/data/ovfdata/other/rawdisk.raw \
1006         test/data/ovfdata/ova.ova \
1007         test/data/ovfdata/rawdisk.raw \
1008         test/data/ovfdata/second_disk.vmdk \
1009         test/data/ovfdata/unsafe_path.ini \
1010         test/data/ovfdata/virtualbox.ovf \
1011         test/data/ovfdata/wrong_config.ini \
1012         test/data/ovfdata/wrong_extension.ovd \
1013         test/data/ovfdata/wrong_manifest.mf \
1014         test/data/ovfdata/wrong_manifest.ovf \
1015         test/data/ovfdata/wrong_ova.ova \
1016         test/data/ovfdata/wrong_xml.ovf \
1017         test/data/proc_drbd8.txt \
1018         test/data/proc_drbd80-emptyline.txt \
1019         test/data/proc_drbd83.txt \
1020         test/data/proc_drbd83_sync.txt \
1021         test/data/proc_drbd83_sync_want.txt \
1022         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1023         test/data/sys_drbd_usermode_helper.txt \
1024         test/data/vgreduce-removemissing-2.02.02.txt \
1025         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1026         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1027         test/data/vgs-missing-pvs-2.02.02.txt \
1028         test/data/vgs-missing-pvs-2.02.66.txt \
1029         test/py/ganeti-cli.test \
1030         test/py/gnt-cli.test \
1031         test/py/import-export_unittest-helper
1032
1033 python_tests = \
1034         doc/examples/rapi_testutils.py \
1035         test/py/cfgupgrade_unittest.py \
1036         test/py/docs_unittest.py \
1037         test/py/ganeti.asyncnotifier_unittest.py \
1038         test/py/ganeti.backend_unittest-runasroot.py \
1039         test/py/ganeti.backend_unittest.py \
1040         test/py/ganeti.bdev_unittest.py \
1041         test/py/ganeti.cli_unittest.py \
1042         test/py/ganeti.client.gnt_cluster_unittest.py \
1043         test/py/ganeti.client.gnt_instance_unittest.py \
1044         test/py/ganeti.client.gnt_job_unittest.py \
1045         test/py/ganeti.cmdlib_unittest.py \
1046         test/py/ganeti.compat_unittest.py \
1047         test/py/ganeti.confd.client_unittest.py \
1048         test/py/ganeti.config_unittest.py \
1049         test/py/ganeti.constants_unittest.py \
1050         test/py/ganeti.daemon_unittest.py \
1051         test/py/ganeti.errors_unittest.py \
1052         test/py/ganeti.hooks_unittest.py \
1053         test/py/ganeti.ht_unittest.py \
1054         test/py/ganeti.http_unittest.py \
1055         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1056         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1057         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1058         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1059         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1060         test/py/ganeti.hypervisor_unittest.py \
1061         test/py/ganeti.impexpd_unittest.py \
1062         test/py/ganeti.jqueue_unittest.py \
1063         test/py/ganeti.jstore_unittest.py \
1064         test/py/ganeti.locking_unittest.py \
1065         test/py/ganeti.luxi_unittest.py \
1066         test/py/ganeti.masterd.iallocator_unittest.py \
1067         test/py/ganeti.masterd.instance_unittest.py \
1068         test/py/ganeti.mcpu_unittest.py \
1069         test/py/ganeti.netutils_unittest.py \
1070         test/py/ganeti.objects_unittest.py \
1071         test/py/ganeti.objectutils_unittest.py \
1072         test/py/ganeti.opcodes_unittest.py \
1073         test/py/ganeti.ovf_unittest.py \
1074         test/py/ganeti.qlang_unittest.py \
1075         test/py/ganeti.query_unittest.py \
1076         test/py/ganeti.rapi.baserlib_unittest.py \
1077         test/py/ganeti.rapi.client_unittest.py \
1078         test/py/ganeti.rapi.resources_unittest.py \
1079         test/py/ganeti.rapi.rlib2_unittest.py \
1080         test/py/ganeti.rapi.testutils_unittest.py \
1081         test/py/ganeti.rpc_unittest.py \
1082         test/py/ganeti.runtime_unittest.py \
1083         test/py/ganeti.serializer_unittest.py \
1084         test/py/ganeti.server.rapi_unittest.py \
1085         test/py/ganeti.ssconf_unittest.py \
1086         test/py/ganeti.ssh_unittest.py \
1087         test/py/ganeti.storage_unittest.py \
1088         test/py/ganeti.tools.ensure_dirs_unittest.py \
1089         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1090         test/py/ganeti.tools.prepare_node_join_unittest.py \
1091         test/py/ganeti.uidpool_unittest.py \
1092         test/py/ganeti.utils.algo_unittest.py \
1093         test/py/ganeti.utils.filelock_unittest.py \
1094         test/py/ganeti.utils.hash_unittest.py \
1095         test/py/ganeti.utils.io_unittest-runasroot.py \
1096         test/py/ganeti.utils.io_unittest.py \
1097         test/py/ganeti.utils.log_unittest.py \
1098         test/py/ganeti.utils.lvm_unittest.py \
1099         test/py/ganeti.utils.mlock_unittest.py \
1100         test/py/ganeti.utils.nodesetup_unittest.py \
1101         test/py/ganeti.utils.process_unittest.py \
1102         test/py/ganeti.utils.retry_unittest.py \
1103         test/py/ganeti.utils.text_unittest.py \
1104         test/py/ganeti.utils.wrapper_unittest.py \
1105         test/py/ganeti.utils.x509_unittest.py \
1106         test/py/ganeti.utils_unittest.py \
1107         test/py/ganeti.vcluster_unittest.py \
1108         test/py/ganeti.workerpool_unittest.py \
1109         test/py/pycurl_reset_unittest.py \
1110         test/py/qa.qa_config_unittest.py \
1111         test/py/tempfile_fork_unittest.py
1112
1113 haskell_tests = test/hs/htest
1114
1115 dist_TESTS = \
1116         test/py/check-cert-expired_unittest.bash \
1117         test/py/daemon-util_unittest.bash \
1118         test/py/ganeti-cleaner_unittest.bash \
1119         test/py/import-export_unittest.bash \
1120         test/py/cli-test.bash \
1121         test/py/bash_completion.bash \
1122         $(python_tests)
1123
1124 nodist_TESTS =
1125 check_SCRIPTS =
1126
1127 if WANT_HSTESTS
1128 nodist_TESTS += $(haskell_tests)
1129 dist_TESTS += test/hs/offline-test.sh
1130 check_SCRIPTS += \
1131         test/hs/hpc-htools \
1132         test/hs/hpc-mon-collector \
1133         $(HS_BUILT_TEST_HELPERS)
1134 endif
1135
1136 TESTS = $(dist_TESTS) $(nodist_TESTS)
1137
1138 # Environment for all tests
1139 PLAIN_TESTS_ENVIRONMENT = \
1140         PYTHONPATH=. \
1141         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1142         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1143         $(RUN_IN_TEMPDIR)
1144
1145 # Environment for tests run by automake
1146 TESTS_ENVIRONMENT = \
1147         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1148
1149 all_python_code = \
1150         $(dist_sbin_SCRIPTS) \
1151         $(python_scripts) \
1152         $(pkglib_python_scripts) \
1153         $(nodist_pkglib_python_scripts) \
1154         $(nodist_tools_python_scripts) \
1155         $(python_tests) \
1156         $(pkgpython_PYTHON) \
1157         $(client_PYTHON) \
1158         $(hypervisor_PYTHON) \
1159         $(rapi_PYTHON) \
1160         $(server_PYTHON) \
1161         $(pytools_PYTHON) \
1162         $(http_PYTHON) \
1163         $(confd_PYTHON) \
1164         $(masterd_PYTHON) \
1165         $(impexpd_PYTHON) \
1166         $(utils_PYTHON) \
1167         $(watcher_PYTHON) \
1168         $(noinst_PYTHON) \
1169         $(qa_scripts)
1170
1171 srclink_files = \
1172         man/footer.rst \
1173         test/py/check-cert-expired_unittest.bash \
1174         test/py/daemon-util_unittest.bash \
1175         test/py/ganeti-cleaner_unittest.bash \
1176         test/py/import-export_unittest.bash \
1177         test/py/cli-test.bash \
1178         test/py/bash_completion.bash \
1179         test/hs/offline-test.sh \
1180         test/hs/cli-tests-defs.sh \
1181         $(all_python_code) \
1182         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1183         $(docinput)
1184
1185 check_python_code = \
1186         $(BUILD_BASH_COMPLETION) \
1187         $(CHECK_IMPORTS) \
1188         $(CHECK_HEADER) \
1189         $(DOCPP) \
1190         $(all_python_code)
1191
1192 lint_python_code = \
1193         ganeti \
1194         ganeti/http/server.py \
1195         $(dist_sbin_SCRIPTS) \
1196         $(python_scripts) \
1197         $(pkglib_python_scripts) \
1198         $(BUILD_BASH_COMPLETION) \
1199         $(CHECK_IMPORTS) \
1200         $(CHECK_HEADER) \
1201         $(DOCPP) \
1202         $(PYTHON_BOOTSTRAP)
1203
1204 standalone_python_modules = \
1205         lib/rapi/client.py \
1206         tools/ganeti-listrunner
1207
1208 pep8_python_code = \
1209         ganeti \
1210         ganeti/http/server.py \
1211         $(dist_sbin_SCRIPTS) \
1212         $(python_scripts) \
1213         $(pkglib_python_scripts) \
1214         $(BUILD_BASH_COMPLETION) \
1215         $(CHECK_HEADER) \
1216         $(DOCPP) \
1217         $(PYTHON_BOOTSTRAP) \
1218         qa
1219
1220 test/py/daemon-util_unittest.bash: daemons/daemon-util
1221
1222 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1223
1224 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1225
1226 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1227         sed -f $(REPLACE_VARS_SED) < $< > $@
1228         chmod +x $@
1229
1230 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1231         sed -f $(REPLACE_VARS_SED) < $< > $@
1232         chmod +x $@
1233
1234 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1235         sed -f $(REPLACE_VARS_SED) < $< > $@
1236         chmod +x $@
1237
1238 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1239         sed -f $(REPLACE_VARS_SED) < $< > $@
1240
1241 doc/examples/bash_completion: BC_ARGS = --compact
1242 doc/examples/bash_completion-debug: BC_ARGS =
1243
1244 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1245         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1246         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1247         daemons/ganeti-cleaner \
1248         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1249         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1250           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1251
1252 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1253         lib/build/shell_example_lexer.py \
1254         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1255         @echo "Checking $< for hardcoded paths..."
1256         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1257           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1258           exit 1; \
1259         fi
1260         set -e ; \
1261         trap 'echo auto-removing $@; rm $@' EXIT; \
1262         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1263         $(CHECK_MAN_REFERENCES) $@; \
1264         trap - EXIT
1265
1266 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1267         @test -n "$(PANDOC)" || \
1268           { echo 'pandoc' not found during configure; exit 1; }
1269         set -o pipefail ; \
1270         trap 'echo auto-removing $@; rm $@' EXIT; \
1271         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1272           sed -e 's/\\@/@/g' > $@; \
1273         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1274         $(CHECK_MAN_DASHES) $@; \
1275         trap - EXIT
1276
1277 man/%.html.in: man/%.gen man/footer.rst
1278         @test -n "$(PANDOC)" || \
1279           { echo 'pandoc' not found during configure; exit 1; }
1280         set -o pipefail ; \
1281         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1282           sed -e 's/\\@/@/g' > $@
1283
1284 man/%: man/%.in  $(REPLACE_VARS_SED)
1285         sed -f $(REPLACE_VARS_SED) < $< > $@
1286
1287 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1288         sed -f $(REPLACE_VARS_SED) < $< > $@
1289
1290 vcs-version:
1291         if test -d .git; then \
1292           git describe > $@; \
1293         elif test ! -f $@ ; then \
1294           echo "Cannot auto-generate $@ file"; exit 1; \
1295         fi
1296
1297 .PHONY: clean-vcs-version
1298 clean-vcs-version:
1299         rm -f vcs-version
1300
1301 .PHONY: regen-vcs-version
1302 regen-vcs-version:
1303         @set -e; \
1304         cd $(srcdir); \
1305         if test -d .git; then \
1306           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1307           git describe > $$T; \
1308           if ! cmp --quiet $$T vcs-version; then \
1309             mv $$T vcs-version; \
1310           fi; \
1311         fi
1312
1313 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1314         vcs-version $(built_base_sources)
1315         set -e; \
1316         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1317         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1318
1319 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1320         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1321         lib/jstore.py $(RUN_IN_TEMPDIR) \
1322         $(CONVERT_CONSTANTS) $(built_base_sources) \
1323         | lib/_vcsversion.py
1324         set -e; \
1325         { cat $< ; \
1326           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1327         } > $@
1328
1329 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1330         $(built_base_sources)
1331         set -e; \
1332         { cat $< ; \
1333           echo ; \
1334           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1335             echo "import $$name ()" ; \
1336           done ; \
1337         } > $@
1338
1339 lib/_autoconf.py: Makefile | stamp-directories
1340         set -e; \
1341         { echo '# This file is automatically generated, do not edit!'; \
1342           echo '#'; \
1343           echo ''; \
1344           echo '"""Build-time configuration for Ganeti.'; \
1345           echo '';\
1346           echo 'This file is autogenerated by the build process.'; \
1347           echo 'For any changes you need to re-run ./configure (and'; \
1348           echo 'not edit by hand).'; \
1349           echo ''; \
1350           echo '"""'; \
1351           echo ''; \
1352           echo '# pylint: disable=C0301,C0324'; \
1353           echo '# because this is autogenerated, we do not want'; \
1354           echo '# style warnings' ; \
1355           echo ''; \
1356           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1357           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1358           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1359           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1360           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1361           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1362           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1363           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1364           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1365           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1366           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1367           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1368           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1369           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1370           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1371           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1372           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1373           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1374           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1375           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1376           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1377           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1378           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1379           echo "KVM_PATH = '$(KVM_PATH)'"; \
1380           echo "IP_PATH = '$(IP_PATH)'"; \
1381           echo "SOCAT_PATH = '$(SOCAT)'"; \
1382           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1383           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1384           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1385           echo "TOOLSDIR = '$(toolsdir)'"; \
1386           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1387           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1388           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1389           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1390           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1391           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1392           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1393           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1394           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1395           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1396           echo "RAPI_USER = '$(RAPI_USER)'"; \
1397           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1398           echo "CONFD_USER = '$(CONFD_USER)'"; \
1399           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1400           echo "NODED_USER = '$(NODED_USER)'"; \
1401           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1402           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1403           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1404           echo "HTOOLS = True"; \
1405           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1406           echo "XEN_CMD = '$(XEN_CMD)'"; \
1407           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1408           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1409           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1410         } > $@
1411
1412 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1413         set -e; \
1414         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1415         { echo '# This file is automatically generated, do not edit!'; \
1416           echo '#'; \
1417           echo ''; \
1418           echo '"""Build-time VCS version number for Ganeti.'; \
1419           echo '';\
1420           echo 'This file is autogenerated by the build process.'; \
1421           echo 'For any changes you need to re-run ./configure (and'; \
1422           echo 'not edit by hand).'; \
1423           echo ''; \
1424           echo '"""'; \
1425           echo ''; \
1426           echo '# pylint: disable=C0301,C0324'; \
1427           echo '# because this is autogenerated, we do not want'; \
1428           echo '# style warnings' ; \
1429           echo ''; \
1430           echo "VCS_VERSION = '$$VCSVER'"; \
1431         } > $@
1432
1433 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1434         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1435
1436 $(SHELL_ENV_INIT): Makefile stamp-directories
1437         set -e; \
1438         { echo '# Allow overriding for tests'; \
1439           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1440           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1441           echo; \
1442           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1443           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1444           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1445           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1446           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1447         } > $@
1448
1449 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1450         set -e; \
1451         { echo 's#@PREFIX@#$(prefix)#g'; \
1452           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1453           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1454           echo 's#@BINDIR@#$(bindir)#g'; \
1455           echo 's#@SBINDIR@#$(sbindir)#g'; \
1456           echo 's#@LIBDIR@#$(libdir)#g'; \
1457           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1458           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1459           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1460           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1461           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1462           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1463           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1464           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1465           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1466           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1467           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1468           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1469           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1470           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1471           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1472           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1473           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1474           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1475           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1476           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1477           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1478           echo; \
1479           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1480           echo '  r $(SHELL_ENV_INIT)'; \
1481           echo '  d'; \
1482           echo '}'; \
1483         } > $@
1484
1485 # Using deferred evaluation
1486 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1487 daemons/ganeti-watcher: MODULE = ganeti.watcher
1488 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1489 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1490 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1491 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1492 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1493 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1494
1495 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1496         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1497         set -e; \
1498         { echo '#!/usr/bin/python'; \
1499           echo '# This file is automatically generated, do not edit!'; \
1500           echo "# Edit $(MODULE) instead."; \
1501           echo; \
1502           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1503           echo; \
1504           echo '# pylint: disable=C0103'; \
1505           echo '# C0103: Invalid name'; \
1506           echo; \
1507           echo 'import sys'; \
1508           echo 'import $(MODULE) as main'; \
1509           echo; \
1510           echo '# Temporarily alias commands until bash completion'; \
1511           echo '# generator is changed'; \
1512           echo 'if hasattr(main, "commands"):'; \
1513           echo '  commands = main.commands # pylint: disable=E1101'; \
1514           echo 'if hasattr(main, "aliases"):'; \
1515           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1516           echo; \
1517           echo 'if __name__ == "__main__":'; \
1518           echo '  sys.exit(main.Main())'; \
1519         } > $@
1520         chmod u+x $@
1521
1522 $(HS_BUILT_TEST_HELPERS): Makefile
1523         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1524         set -e; \
1525         { echo '#!/bin/sh'; \
1526           echo '# This file is automatically generated, do not edit!'; \
1527           echo "# Edit Makefile.am instead."; \
1528           echo; \
1529           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1530         } > $@
1531         chmod u+x $@
1532
1533 stamp-directories: Makefile
1534         $(MAKE) $(AM_MAKEFLAGS) ganeti
1535         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1536         touch $@
1537
1538 # We need to create symlinks because "make distcheck" will not install Python
1539 # files when building.
1540 stamp-srclinks: Makefile | stamp-directories
1541         set -e; \
1542         for i in $(srclink_files); do \
1543           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1544             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1545           fi; \
1546         done
1547         touch $@
1548
1549 .PHONY: ganeti
1550 ganeti:
1551         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1552
1553 .PHONY: check-dirs
1554 check-dirs: $(GENERATED_FILES)
1555         @set -e; \
1556         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1557           error=; \
1558           while read dir; do \
1559             case "$$dir" in \
1560               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1561               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1562             esac; \
1563           done; \
1564           for dir in $(DIRS); do \
1565             if ! test -d "$$dir"; then \
1566               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1567               error=1; \
1568             fi \
1569           done; \
1570           test -z "$$error"; \
1571         }
1572
1573 .PHONY: check-local
1574 check-local: check-dirs $(GENERATED_FILES)
1575         $(CHECK_PYTHON_CODE) $(check_python_code)
1576         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1577         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1578         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1579         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1580         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1581         error= ; \
1582         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1583           echo "Incorrect version in README, expected $$expver" >&2; \
1584           error=1; \
1585         fi; \
1586         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1587             doc/security.rst; do \
1588           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1589             "Documents Ganeti version $$expver"; then \
1590             echo "Incorrect version in $$file, expected $$expver" >&2; \
1591             error=1; \
1592           fi; \
1593         done; \
1594         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1595           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1596           error=1; \
1597         fi; \
1598         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1599           ".. Last updated for Ganeti $$expver"; then \
1600           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1601           error=1; \
1602         fi; \
1603         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1604           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1605             echo "Longest line in $$file is longer than 80 characters" >&2; \
1606             error=1; \
1607           fi; \
1608         done; \
1609         test -z "$$error"
1610
1611 .PHONY: hs-tests
1612 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1613         @rm -f htest.tix
1614         ./test/hs/htest
1615
1616 .PHONY: hs-shell
1617 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1618         @rm -f hpc-htools.tix hpc-mon-collector.tix
1619         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1620
1621 .PHONY: hs-check
1622 hs-check: hs-tests hs-shell
1623
1624 # E111: indentation is not a multiple of four
1625 # E121: continuation line indentation is not a multiple of four
1626 #       (since our indent level is not 4)
1627 # E125: continuation line does not distinguish itself from next logical line
1628 #       (since our indent level is not 4)
1629 # E127: continuation line over-indented for visual indent
1630 #       (since our indent level is not 4)
1631 # note: do NOT add E128 here; it's a valid style error in most cases!
1632 # I've seen real errors, but also some cases were we indent wrongly
1633 # due to line length; try to rework the cases where it is triggered,
1634 # instead of silencing it
1635 # E261: at least two spaces before inline comment
1636 # E501: line too long (80 characters)
1637 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1638
1639 # For excluding pep8 expects filenames only, not whole paths
1640 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1641
1642 LINT_TARGETS = pylint pylint-qa
1643 if HAS_PEP8
1644 LINT_TARGETS += pep8
1645 endif
1646 if HAS_HLINT
1647 LINT_TARGETS += hlint
1648 endif
1649
1650 .PHONY: lint
1651 lint: $(LINT_TARGETS)
1652
1653 .PHONY: pylint
1654 pylint: $(GENERATED_FILES)
1655         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1656         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1657
1658 .PHONY: pylint-qa
1659 pylint-qa: $(GENERATED_FILES)
1660         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1661         cd $(top_srcdir)/qa && \
1662           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1663           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1664
1665 .PHONY: pep8
1666 pep8: $(GENERATED_FILES)
1667         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1668         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1669           --repeat $(pep8_python_code)
1670
1671 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1672 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1673 .PHONY: hlint
1674 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1675         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1676         if tty -s; then C="-c"; else C=""; fi; \
1677         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1678           --ignore "Use first" \
1679           --ignore "Use &&&" \
1680           --ignore "Use void" \
1681           --ignore "Reduce duplication" \
1682           --hint src/lint-hints \
1683           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1684
1685 # a dist hook rule for updating the vcs-version file; this is
1686 # hardcoded due to where it needs to build the file...
1687 dist-hook:
1688         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1689         rm -f $(top_distdir)/vcs-version
1690         cp -p $(srcdir)/vcs-version $(top_distdir)
1691 if MANPAGES_IN_DOC
1692         echo 'Building distribution with man pages included in documentation is' \
1693              'not allowed as they can contain fixed paths' >&2; \
1694         exit 1
1695 endif
1696
1697 # a distcheck hook rule for catching revision control directories
1698 distcheck-hook:
1699         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1700           echo "Found revision control files in final archive." 1>&2; \
1701           exit 1; \
1702         fi
1703         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1704           echo "Found Python byte code in final archive." 1>&2; \
1705           exit 1; \
1706         fi
1707         if find $(top_distdir) -name '*~' | grep .; then \
1708           echo "Found backup files in final archive." 1>&2; \
1709           exit 1; \
1710         fi
1711 # Empty files or directories should not be distributed. They can cause
1712 # unnecessary warnings for packagers. Directories used by automake during
1713 # distcheck must be excluded.
1714         if find $(top_distdir) -empty -and -not \( \
1715             -path $(top_distdir)/_build -or \
1716             -path $(top_distdir)/_inst \) | grep .; then \
1717           echo "Found empty files or directories in final archive." 1>&2; \
1718           exit 1; \
1719         fi
1720         if test -n "$(BUILD_RELEASE)" && \
1721            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1722            echo "Found unreleased version in NEWS." >&2; \
1723            exit 1; \
1724         fi
1725
1726 # When building a release, stricter checks should be used
1727 distcheck-release dist-release: export BUILD_RELEASE = 1
1728 distcheck-release: distcheck
1729
1730 distrebuildcheck: dist
1731         set -e; \
1732         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1733         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1734         cd $$builddir; \
1735         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1736         cd $(distdir); \
1737         ./configure; \
1738         $(MAKE) maintainer-clean; \
1739         cp $(abs_srcdir)/vcs-version .; \
1740         ./configure; \
1741         $(MAKE) $(AM_MAKEFLAGS)
1742
1743 dist-release: dist
1744         set -e; \
1745         for i in $(DIST_ARCHIVES); do \
1746           echo -n "Checking $$i ... "; \
1747           autotools/check-tar < $$i; \
1748           echo OK; \
1749         done
1750
1751 install-exec-local:
1752         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1753           "$(DESTDIR)${localstatedir}/log/ganeti" \
1754           "$(DESTDIR)${localstatedir}/run/ganeti"
1755
1756 .PHONY: apidoc
1757 if WANT_HSAPIDOC
1758 apidoc: py-apidoc hs-apidoc
1759 else
1760 apidoc: py-apidoc
1761 endif
1762
1763 .PHONY: py-apidoc
1764 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1765         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1766         $(RUN_IN_TEMPDIR) epydoc -v \
1767           --conf $(CURDIR)/epydoc.conf \
1768           --output $(CURDIR)/$(APIDOC_PY_DIR)
1769
1770 .PHONY: hs-apidoc
1771 hs-apidoc: $(HS_BUILT_SRCS)
1772         @test -n "$(HSCOLOUR)" || \
1773             { echo 'HsColour' not found during configure; exit 1; }
1774         @test -n "$(HADDOCK)" || \
1775             { echo 'haddock' not found during configure; exit 1; }
1776         rm -rf $(APIDOC_HS_DIR)/*
1777         for i in $(ALL_APIDOC_HS_DIRS); do \
1778           @mkdir_p@ $$i; \
1779         done
1780         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1781         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1782         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1783         set -e ; \
1784         cd src; \
1785         if [ "$(HS_NOCURL)" ]; \
1786         then OPTGHC="--optghc=$(HS_NOCURL)"; \
1787         else OPTGHC=""; \
1788         fi; \
1789         if [ "$(HS_PARALLEL3)" ]; \
1790         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1791         fi; \
1792         if [ "$(HS_REGEX_PCRE)" ]; \
1793         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1794         fi; \
1795         RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
1796         for file in $$RELSRCS; do \
1797           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1798           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1799         done ; \
1800         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1801           -t ganeti -p haddock-prologue \
1802           --source-module="%{MODULE/.//}.html" \
1803           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1804           $$OPTGHC \
1805           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
1806
1807 .PHONY: TAGS
1808 TAGS: $(GENERATED_FILES)
1809         rm -f TAGS
1810         $(GHC) -e ":etags" -v0 \
1811           $(filter-out -O -Werror,$(HFLAGS)) \
1812           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1813           $(HS_LIBTEST_SRCS)
1814         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1815           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1816           -path './qa/*.py' | \
1817           etags -l python -a -
1818
1819 .PHONY: coverage
1820 if WANT_HTOOLS
1821 coverage: py-coverage hs-coverage
1822 else
1823 coverage: py-coverage
1824 endif
1825
1826 .PHONY: py-coverage
1827 py-coverage: $(GENERATED_FILES) $(python_tests)
1828         @test -n "$(PYCOVERAGE)" || \
1829             { echo 'python-coverage' not found during configure; exit 1; }
1830         set -e; \
1831         COVERAGE=$(PYCOVERAGE) \
1832         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1833         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1834         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1835         $(PLAIN_TESTS_ENVIRONMENT) \
1836         $(abs_top_srcdir)/autotools/gen-py-coverage \
1837         $(python_tests)
1838
1839 .PHONY: hs-coverage
1840 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1841         rm -f *.tix
1842         $(MAKE) $(AM_MAKEFLAGS) hs-check
1843         @mkdir_p@ $(COVERAGE_HS_DIR)
1844         hpc sum --union $(HPCEXCL) \
1845           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1846         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1847         hpc report coverage-hs.tix
1848         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1849
1850 # Special "kind-of-QA" target for htools, needs special setup (all
1851 # tools compiled with -fhpc)
1852 .PHONY: live-test
1853 live-test: all
1854         set -e ; \
1855         cd src; \
1856         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1857         rm -f *.tix *.mix; \
1858         ./live-test.sh; \
1859         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1860           --output=live-test.tix ; \
1861         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1862         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1863           --srcdir=.. $(HPCEXCL) ; \
1864         hpc report --srcdir=.. live-test $(HPCEXCL)
1865
1866 commit-check: distcheck lint apidoc
1867
1868 .PHONY: gitignore-check
1869 gitignore-check:
1870         @if [ -n "`git status --short`" ]; then \
1871           echo "Git status is not clean!" 1>&2 ; \
1872           git status --short; \
1873           exit 1; \
1874         fi
1875
1876 # target to rebuild all man pages (both groff and html output)
1877 .PHONY: man
1878 man: $(man_MANS) $(manhtml)
1879
1880 # Target that builds all binaries (including those that are not
1881 # rebuilt except when running the tests)
1882 .PHONY: really-all
1883 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1884
1885 # we don't need the ancient implicit rules:
1886 %: %,v
1887 %: RCS/%,v
1888 %: RCS/%
1889 %: s.%
1890 %: SCCS/s.%
1891
1892 -include ./Makefile.local
1893
1894 # vim: set noet :